=== debian/changelog ===
nlohmann-json (2.0.6-1) unstable; urgency=medium

  * New upstream version 2.0.5
  * New upstream version 2.0.6

 -- Muri Nicanor <muri@immerda.ch>  Sun, 23 Oct 2016 22:49:30 +0200
