## nlohmann-json 2.1.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,7 +1,7 @@
 cmake_minimum_required(VERSION 3.0)
 
 # define the project
-project(nlohmann_json VERSION 2.0.6 LANGUAGES CXX)
+project(nlohmann_json VERSION 2.1.1 LANGUAGES CXX)
 
 enable_testing()
 
@@ -16,6 +16,8 @@
 set(JSON_CONFIG_DESTINATION "cmake")
 set(JSON_INCLUDE_DESTINATION "include/nlohmann")
 
+set(CMAKE_MODULE_PATH "${CMAKE_SOURCE_DIR}/cmake")
+
 # create and configure the library target
 add_library(${JSON_TARGET_NAME} INTERFACE)
 target_include_directories(${JSON_TARGET_NAME} INTERFACE
@@ -23,7 +25,7 @@
   $<INSTALL_INTERFACE:${JSON_INCLUDE_DESTINATION}>)
 
 # create and configure the unit test target
-if (BuildTests)
+if(BuildTests)
     add_subdirectory(test)
 endif()
 
@@ -39,17 +41,17 @@
 
 # export the library target and store build directory in package registry
 export(TARGETS ${JSON_TARGET_NAME}
-	FILE "${CMAKE_CURRENT_BINARY_DIR}/${JSON_TARGETS_FILENAME}")
+    FILE "${CMAKE_CURRENT_BINARY_DIR}/${JSON_TARGETS_FILENAME}")
 export(PACKAGE ${JSON_PACKAGE_NAME})
 
 # install library target and config files
 install(TARGETS ${JSON_TARGET_NAME}
-	EXPORT ${JSON_PACKAGE_NAME})
+    EXPORT ${JSON_PACKAGE_NAME})
 install(FILES "src/json.hpp"
-	DESTINATION ${JSON_INCLUDE_DESTINATION})
+    DESTINATION ${JSON_INCLUDE_DESTINATION})
 install(EXPORT ${JSON_PACKAGE_NAME}
-	FILE ${JSON_TARGETS_FILENAME}
-	DESTINATION ${JSON_CONFIG_DESTINATION})
+    FILE ${JSON_TARGETS_FILENAME}
+    DESTINATION ${JSON_CONFIG_DESTINATION})
 install(FILES "${CMAKE_CURRENT_BINARY_DIR}/${JSON_CONFIG_FILENAME}"
-	"${CMAKE_CURRENT_BINARY_DIR}/${JSON_CONFIGVERSION_FILENAME}"
-	DESTINATION ${JSON_CONFIG_DESTINATION})
+    "${CMAKE_CURRENT_BINARY_DIR}/${JSON_CONFIGVERSION_FILENAME}"
+    DESTINATION ${JSON_CONFIG_DESTINATION})
