=== debian/changelog ===
nlohmann-json (2.1.1-1.1) unstable; urgency=medium

  * Non-maintainer upload.
  * debian/patches/bea1665ac9a5e7aa4fa93668ff35723385a27bfd.patch:
    cherry-pick upstream fix for new gcc 7.2 (Closes: #892201)

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Mon, 23 Apr 2018 11:07:57 +0200

nlohmann-json (2.1.1-1) unstable; urgency=medium

  * New upstream version 2.1.1 (Closes: #885540)
  * Switched build system to cmake, library is now installed in
    /usr/include/nlohmann, which is upstream default (Closes: #868112)

 -- Muri Nicanor <muri@immerda.ch>  Wed, 12 Jul 2017 21:00:07 +0200
