=== debian/control ===
--- 
+++ 
@@ -2,6 +2,7 @@
 Priority: optional
 Maintainer: Muri Nicanor <muri@immerda.ch>
 Build-Depends:
+ cmake,
  debhelper (>=9),
  doxygen,
  ghostscript,
@@ -16,6 +17,7 @@
 Package: nlohmann-json-dev
 Section: libdevel
 Architecture: all
+Multi-Arch: foreign
 Depends:
  ${misc:Depends},
 Description: JSON for Modern C++
