=== debian/rules ===
--- 
+++ 
@@ -5,17 +5,15 @@
 
 
 %:
-	dh $@ 
+	dh $@ --buildsystem=cmake
 
 override_dh_clean:
 	dh_clean
 	make -C doc clean
-
-override_dh_auto_test:
-	make all
 
 override_dh_auto_build:
 	make re2c
 	make -C doc
 	rm -f doc/html/*.md5
 	rm -f doc/html/jquery.js
+	dh_auto_build
